// arduino and lcd clock
// use timerOne 16 bit timer
// to calibrate this clock:
// use a good seconds clock like a GPS.
// use hours as baseline. Count seconds
// THIS is off. If THIS is behind a GPS
// GPS=00..THIS=58  SUBTRACT 277 for each 
// second/hours. 
// Example: slower by 2 sec in 3 hours...
// (277 * 2)/3 = 184  
// SUBTRACT from tSec.
//
// if THIS is ahead  GPS=00...THIS=03
// same math just ADD to tSec.
// cauction, most clocks correct at 00.
// 20 sec is a better timer check.
// tSec is stored in EEPROM. To change tSec
// best to use 'calibrate' or if you know how...
// 
// cauction: any menu will interrupt current time
// and reset seconds to 00.
// so clock will be off.
// and day date can be 31 for any month.
//


#include <TimerOne.h> //16 bit clock
#include <EEPROM.h>  //store tSec 
 //////////////////////////////////////////////////
#include <LiquidCrystal_I2C.h> //use A4=sda  A5=scl
//Set LCD I2C address vvvv
LiquidCrystal_I2C lcd(0x3F,16,2); 


/////// example of comparing seconds to calibrate
// gps=00 THIS=57  slow = subtract
// gps=00 THIS=02  fast = add
// calibrate this number tSec 277=1sec per hour 
 unsigned long tSec = 1000128; //.1sec see above
 ///////////////  was 1000124
 ///////////////  was 1,000,000 //way off

 ////////////////////////////////////////////
 ////////////////////////////////////////////
 /// enter clock start-up times + dates here
 
 int countSec=0;    //0-59 always start at 0
 int countMin=0;    //0-59
 int countHou=0;    //24hour  0-11am  12-23pm   
 int countDay=25;   //never 0
 int countMon=11;   //never 0
 int countYea=19;   //never 0

/////////  end enter times ///////////////////

int countSecOld;
long unsigned tMenu;
byte dHou=countHou; //display only

byte dig;  //10 digits display
byte unit; //1 units  display

int swDelay = 250; //button delay debounce
unsigned int menuDelay=60000; //60 sec then returns

///////  LCD CUSTOM NUMBERS arrays  /////////////////
byte bar1[8] = { 6,6,6,6,6,6,6,6 };        // = |
byte bar2[8] = { 31,31,3,3,3,3,3,3 };      // = 7
byte bar3[8] = { 31,3,3,3,3,3,31,31 };     // = C lft
byte bar4[8] = { 19,19,19,19,19,19,31,31 };// = C up
byte bar5[8] = { 31,31,24,24,24,24,31,31 };// = C
byte bar6[8] = { 31,31,19,19,19,19,31,31 };// = []
byte bar7[8] = { 31,31,19,19,19,19,19,19 };// = C dn
byte bar8[8] = { 3,3,3,3,3,3,3,3 };       // = | rite


void setup() { 
//  Serial.begin(9600); 
//  Serial.println(" starting at 0 ");

//////////////////////////////////////////////
// store 'tSec' for first time only    ///////
 if (EEPROM.read(200)==0) { 
  EEPROM.put(200,55);
  EEPROM.put(300,tSec); 
  }
////////////////////////////////////////////// 
 EEPROM.get(300,tSec);

  pinMode(10, INPUT_PULLUP); //menu
  pinMode(A1, INPUT_PULLUP); //down
  pinMode(A2, INPUT_PULLUP); //up
  pinMode(A3, INPUT_PULLUP); //enter/exit
  
  Timer1.initialize(tSec); // set a timer 16 bit
  // attach service routine here
  Timer1.attachInterrupt( timerIsr ); 
  
 lcd.begin(); 
  // assignes each custom segment a write number  
  lcd.createChar(1,bar1); 
  lcd.createChar(2,bar2);
  lcd.createChar(3,bar3);
  lcd.createChar(4,bar4);
  lcd.createChar(5,bar5);
  lcd.createChar(6,bar6);
  lcd.createChar(7,bar7);
  lcd.createChar(8,bar8); 

 timePo(); 
}
 
void loop() {
   if (digitalRead(10)==0) { //switch pushed
    tMenu=millis(); //start keypad timmer
    menu(); 
    }
  
  if (countSecOld != countSec) {
    countSecOld=countSec;
    dig = countSec/10 %10;
    unit = countSec % 10; // 0-9
    printNumber(dig, 6);  //prints costom numbers
    printNumber(unit, 7);  // (number, column) 
  }
  
  if (countSec>=60) {
    countSec=0;
    countMin++;
    
  if (countMin>=60) {
    countMin=0;
    countHou++;
  }
  if (countHou>=24) {
    countHou=0;
    countDay++; 
    dayCheck();
  }
    timePo(); //after all adjustments
  } //end if sec 60

  
} //end main  #################################
   
/// --------------------------
/// Custom ISR Timer Routine
/// --------------------------
void timerIsr()
{ countSec++; }  //was countSecOld
 //end isr ####################################

///////////////////////////////////////////////
///  functions    
///
///////////////////////////////////////////////

//////////////   menu  ////////////////////////
 void menu(void) {
 byte ud=0;
    lcd.clear();
    lcd.setCursor(0,1);
    lcd.print(countHou);
    lcd.setCursor(3,1);
    lcd.print(countMin);
    lcd.setCursor(8,1);
    lcd.print(countMon);
    lcd.setCursor(11,1);
    lcd.print(countDay);
    lcd.setCursor(14,1);
    lcd.print(countYea);

  while (millis()-tMenu < menuDelay) {
      
  lcd.setCursor(0,0);

 if (digitalRead(A2)==0) { //up
  delay(swDelay); ud++; tMenu=millis();
  if (ud>5) { ud=0; }
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); ud--; tMenu=millis();
  if (ud>=250) { ud=5; } 
 }
 if (digitalRead(A3)==0) { //enter
  delay(swDelay);
  lcd.setCursor(0,0);
 if (ud==0) { lcd.print("vv hour         "); }
 if (ud==1) { lcd.print("   vv minute    "); }
 if (ud==2) { lcd.print("  month vv      "); }
 if (ud==3) { lcd.print("       day vv   "); }
 if (ud==4) { lcd.print("         year vv"); }
 tMenu=millis();  
 break;
 }

 if (ud==0) { lcd.print("vv              "); }
 if (ud==1) { lcd.print("   vv           "); }
 if (ud==2) { lcd.print("        vv      "); }
 if (ud==3) { lcd.print("           vv   "); }
 if (ud==4) { lcd.print("              vv"); }
 if (ud==5) { lcd.print("    CALIBRATE   "); }
  } //end while 1st menu


 while (millis()-tMenu < menuDelay) {
 if (ud==0)  { 
 if (digitalRead(A2)==0) { //up
  delay(swDelay); countHou++;  tMenu=millis();  
  if (countHou>23) { countHou=0; }
   lcd.setCursor(0,1);
   lcd.print("  ");
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); countHou--; tMenu=millis();
  if (countHou<0) { countHou=23; }
   lcd.setCursor(0,1);
   lcd.print("  "); 
 }
 if (digitalRead(A3)==0) { //enter
   break;
 }
 
    
   lcd.setCursor(0,1);
   lcd.print(countHou); 
 
   }
    
 if (ud==1) {
 if (digitalRead(A2)==0) { //up
  delay(swDelay); countMin++; tMenu=millis();
  if (countMin>59) { countMin=0; }
   lcd.setCursor(3,1);
   lcd.print("  ");
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); countMin--; tMenu=millis();
  if (countMin<0) { countMin=59; } 
   lcd.setCursor(3,1);
   lcd.print("  ");
 }
 if (digitalRead(A3)==0) { //enter
   break;
 }      
   lcd.setCursor(3,1);
   lcd.print(countMin); 
    }     

 if (ud==2) {
 if (digitalRead(A2)==0) { //up
  delay(swDelay); countMon++; tMenu=millis();
  if (countMon>12) { countMon=1; }
   lcd.setCursor(8,1);
   lcd.print("  ");
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); countMon--; tMenu=millis();
  if (countMon<1) { countMon=12; } 
   lcd.setCursor(8,1);
   lcd.print("  ");
 }
 if (digitalRead(A3)==0) { //enter
   break;
 }  
   lcd.setCursor(8,1);
   lcd.print(countMon); 
    }

 if (ud==3) {
 if (digitalRead(A2)==0) { //up
  delay(swDelay); countDay++; tMenu=millis();
  if (countDay>31) { countDay=1; }
   lcd.setCursor(11,1);
   lcd.print("  ");
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); countDay--; tMenu=millis();
  if (countDay<1) { countDay=31; }
   lcd.setCursor(11,1);
   lcd.print("  "); 
 }
 if (digitalRead(A3)==0) { //enter
   break;
 }     
   lcd.setCursor(11,1);
   lcd.print(countDay); 
    }
     
 if (ud==4) {
 if (digitalRead(A2)==0) { //up
  delay(swDelay); countYea++;  tMenu=millis();
  if (countYea>60) { countYea=18; }
   lcd.setCursor(14,1);
   lcd.print("  ");
 }
 if (digitalRead(A1)==0) { //down
  delay(swDelay); countYea--;  tMenu=millis();
  if (countYea<18) { countYea=60; } 
   lcd.setCursor(14,1);
   lcd.print("  ");
 }
 if (digitalRead(A3)==0) { //enter
   break;
 }      
   lcd.setCursor(14,1); 
   lcd.print(countYea); 
    }

 if (ud==5) { calibrateMenu(); break; }
 
 } //end while 2nd menu
  
 lcd.clear();
 countSec=0; //reset sec to zero
 timePo();
 } //end menu() ##################################



void calibrateMenu(void) {
  lcd.clear();
  lcd.print("CALIBRATE  by   ");
  lcd.setCursor(0,1);
  lcd.print("increments of 2 ");
  delay(3000);
  lcd.clear();
  lcd.print("'E' will exit   ");
  lcd.setCursor(0,1);
  lcd.print("- or + to change"); 
  delay(3000);
  lcd.clear();
  lcd.print("THIS slow hit - ");
  lcd.setCursor(0,1);
  lcd.print("THIS fast hit + ");
  delay(3000);
  lcd.clear();
  lcd.print("- slow    + fast");
  lcd.setCursor(0,1);
  lcd.print(tSec); 
  lcd.print("   E exit");

  while (millis()-tMenu < menuDelay) {

  if (digitalRead(A2)==0) { //up
  delay(swDelay);
  tSec=tSec+2;
  EEPROM.put(300,tSec);
  Timer1.initialize(tSec); // set a timer 16 bit
  // attach service routine here
  Timer1.attachInterrupt( timerIsr ); 
  lcd.setCursor(0,0);
  lcd.print(tSec);
  lcd.print(" now +2   ");
  lcd.setCursor(10,1);
  lcd.print("       ");
  delay(4000);
  tMenu=0;
 }

 
 if (digitalRead(A1)==0) { //down
  delay(swDelay);
  tSec=tSec-2;
  EEPROM.put(300,tSec);
  Timer1.initialize(tSec); // set a timer 16 bit
  // attach service routine here
  Timer1.attachInterrupt( timerIsr ); 
  lcd.setCursor(0,0);
  lcd.print(tSec);
  lcd.print(" now -2   ");
  lcd.setCursor(10,1);
  lcd.print("       ");
  delay(4000);
  tMenu=0; 
 }
 
 if (digitalRead(A3)==0) { //enter/exit
  lcd.clear();
  lcd.print("   NO CHANGES   ");
  delay(4000);
  tMenu=0; 
 }
  } //end while mills   
} //end cal menu() #############################
 
void timePo(void) {
  //////////////////  po  hour  //////////////
  dHou=countHou;
  if (countHou>=13) { dHou=countHou-12; }
  if (countHou==0)  { dHou=12; }
  
  if (dHou > 9) {
  dig = dHou/10 % 10;
  } else { dig = 11; } //blank out zero    
  unit = dHou % 10; // 0-9
  printNumber(dig, 0);  //prints costom numbers
  printNumber(unit, 1);  // (number, column)
  lcd.write(165); //dot
  lcd.setCursor(2,0);
  lcd.write(46); //dot
 /////////////   po  minutes  ///////////////////
  dig = countMin/10 %10;
  unit = countMin % 10; // 0-9
  printNumber(dig, 3);  //prints costom numbers
  printNumber(unit, 4);  // (number, column)
  lcd.write(165); //dot
  lcd.setCursor(5,0);
  lcd.write(46); //dot

////////////////  po date  ///////////////////////  
 lcd.setCursor(9,0);
 if (countHou<=11) { 
  lcd.print("AM "); 
  } else {
  lcd.print("PM ");  
  }
 
 byte ww=dayOfWeek(countYea,countMon,countDay);
 if (ww==0) { lcd.print("SUN "); }
 if (ww==1) { lcd.print("MON "); }
 if (ww==2) { lcd.print("TUE "); }
 if (ww==3) { lcd.print("WED "); }
 if (ww==4) { lcd.print("THR "); } 
 if (ww==5) { lcd.print("FRI "); }
 if (ww==6) { lcd.print("SAT "); }
 lcd.setCursor(8,1);
 if (countMon<=9) { lcd.print(" "); }
 lcd.print(countMon);
 lcd.print("/");
 lcd.print(countDay);
 lcd.print("/");
 lcd.print(countYea);
 lcd.print("  ");
 
 } //end timePo()  ##############################   

///////////////////////////////////////////////////
//// dow()    returns 0 to 6, su,mo,tu,we,th,fr,sa
 byte dayOfWeek
  (uint16_t myear, uint8_t mmonth, uint8_t mday)
  {
 if (myear<2000) { myear=myear+2000; }//2019 for 19
 uint16_t months[] = 
 { 0,31,59,90,120,151,181,212,243,273,304,334,365 };
 uint32_t days = myear * 365;    
  for (uint16_t i=4; i<myear; i+=4) { 
    if (((i>0) && !(i%4) && 
       ((i%100) || !(i%400)))) { days++; } 
  } 
  days += months[mmonth-1] + mday;  
  if ((mmonth > 2) && 
       ((myear>0) && !(myear%4) && 
       ( (myear%100) || !(myear%400) ))) days++; 
  return days % 7;  
 } //end dayOfWeek() ###############################

/////////////  dayCheck()  /////////////////////
void dayCheck() {
 if (countDay>=32) {
    countDay=1; 
    countMon++; 
  }
   if (countDay==29 && countMon==2 && 
      countYea &4 !=0) { 
        countDay=1;
        countMon++;
      } 
 if (countDay==30 && countMon==2) { 
    countDay=1;
    countMon++;
    }
 if (countDay==31 && (countMon==4 || 
  countMon==6 || countMon==9 || countMon==11)) {
    countDay=1;
    countMon++;
  }
 if (countMon>=13) { countMon=1; countYea++; }
} //end dayCheck() ###############################


 ////////////////////////////////////////////
 //     custom char functions   
 ////////////////////////////////////////////
 void custom0(byte col) { 
  lcd.setCursor(col,0);  lcd.write(7);
  lcd.setCursor(col,1);  lcd.write(4); }

void custom1(byte col) {
  lcd.setCursor(col,0);  lcd.write(1); 
  lcd.setCursor(col,1);  lcd.write(1); }

void custom2(byte col) {
  lcd.setCursor(col,0);  lcd.write(2); 
  lcd.setCursor(col,1);  lcd.write(5); }
  
void custom3(byte col) {
  lcd.setCursor(col,0);  lcd.write(3); 
  lcd.setCursor(col,1);  lcd.write(3); }  

void custom4(byte col) {
  lcd.setCursor(col,0);  lcd.write(4);
  lcd.setCursor(col,1);  lcd.write(8); }   

void custom5(byte col) {
  lcd.setCursor(col,0);  lcd.write(5); 
  lcd.setCursor(col,1);  lcd.write(3); }  

void custom6(byte col) {
  lcd.setCursor(col,0);  lcd.write(5); 
  lcd.setCursor(col,1);  lcd.write(6); }

void custom7(byte col) {
  lcd.setCursor(col,0);  lcd.write(2); 
  lcd.setCursor(col,1);  lcd.write(1); }  

void custom8(byte col) {
  lcd.setCursor(col,0);  lcd.write(6); 
  lcd.setCursor(col,1);  lcd.write(6); } 
  
void custom9(byte col) {
  lcd.setCursor(col,0);  lcd.write(6);  
  lcd.setCursor(col,1);  lcd.write(8); }  

void custom11(byte col) { //blank screen
  lcd.setCursor(col,0);  lcd.print(" "); 
  lcd.setCursor(col,1);  lcd.print(" "); }

void printNumber(byte value, byte col) {
  switch (value) {
   case 0: custom0(col); break;
   case 1: custom1(col); break;
   case 2: custom2(col); break;  
   case 3: custom3(col); break;
   case 4: custom4(col); break;
   case 5: custom5(col); break;
   case 6: custom6(col); break;
   case 7: custom7(col); break;
   case 8: custom8(col); break;
   case 9: custom9(col); break;   
  case 11: custom11(col); break;
  }
}  

